////////////////////////////////////////////////////////////////////////////////
// Mechanical trade system for MetaTrader 5                                   //
// Copyright (c) 2010 Interesting                                             //
////////////////////////////////////////////////////////////////////////////////
// Mechanical trade system for trading on market Forex                        //
// Example of getting a  MarketBook in the custom expert.                     //
// Unit: MarketBook-Example                                                   //
////////////////////////////////////////////////////////////////////////////////
// Version:      1.0                                                          //
// Version File: 1.0.0.0                                                      //
// File name: MarketBook-Example.mq5                                          //
////////////////////////////////////////////////////////////////////////////////
//                                  Property                                  //
////////////////////////////////////////////////////////////////////////////////
#property description "Mechanical trade system for trading on market Forex"
#property description "Example of getting a  MarketBook in the custom expert"
#property description "Version File: 1.0.0.0"
#property copyright   "Copyright 2010, Interesting"
#property link        "http://www.mql5.com/ru/"
////////////////////////////////////////////////////////////////////////////////
//              Object classes, used in working the trade system              //
////////////////////////////////////////////////////////////////////////////////
//Class CMqlTradeExpert
class CMqlTradeExpert
//Base class of the object "Trade expert"
{
//----------------------------------------------------------------------------//
protected:
//----------------------------------------------------------------------------//
//                    Protected variables for object class                    //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//           Protected procedures and functions of the object class           //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
public:
//----------------------------------------------------------------------------//
//                     Public characteristics of the class                    //
//----------------------------------------------------------------------------//
bool MarketBookActive;
//----------------------------------------------------------------------------//
//                         Constructor and Destructor                         //
//----------------------------------------------------------------------------//
void CMqlTradeExpert();  //Constructor of the class
void ~CMqlTradeExpert(); //Destructor of the class
//----------------------------------------------------------------------------//
//                Public procedures and functions of the class                //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                   Public events and methods of the class                   //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
};
////////////////////////////////////////////////////////////////////////////////
//             Global variables, used in working the trade system             //
////////////////////////////////////////////////////////////////////////////////
CMqlTradeExpert TradeExpert; //Trade expert
////////////////////////////////////////////////////////////////////////////////
//                       Expert initialization function                       //
////////////////////////////////////////////////////////////////////////////////
int OnInit()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
return(0);
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                      Expert deinitialization function                      //
////////////////////////////////////////////////////////////////////////////////
void OnDeinit(const int reason)
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                           Expert Ticks function                            //
////////////////////////////////////////////////////////////////////////////////
void OnTick()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//  
}
////////////////////////////////////////////////////////////////////////////////
//                           Expert Timer function                            //
////////////////////////////////////////////////////////////////////////////////
void OnTimer()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                         Expert Book Event function                         //
////////////////////////////////////////////////////////////////////////////////
void OnBookEvent(const string& symbol)
{
//----------------------------------------------------------------------------//
//Work variables
MqlBookInfo ArrMarketBookInfo[];

ENUM_BOOK_TYPE Type;
double Price;
long Volume;

bool getBook;
int  BookSize;

int f=0;
//----------------------------------------------------------------------------//

  if(symbol ==_Symbol)
  {
  getBook = MarketBookGet(symbol,ArrMarketBookInfo);

    if(getBook)
    //   
    {
    BookSize = ArraySize(ArrMarketBookInfo);
    
      for(f=0;f<BookSize;f++)
      {
      Price  = ArrMarketBookInfo[f].price;
      Volume = ArrMarketBookInfo[f].volume;
      Type   = ArrMarketBookInfo[f].type;
      
      Print(" ",f," Price = ",Price," Volume = ",Volume," Type = ",Type);
      }

    }
    else
    //       
    {
    Print("       ",symbol);
    }

  }
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                        Expert Chart Event function                         //
////////////////////////////////////////////////////////////////////////////////
void OnChartEvent(const int id,         //    
                  const long& lparam,   //    long
                  const double& dparam, //    double
                  const string& sparam  //    string
                  )
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                          Processing user events                            //
//----------------------------------------------------------------------------//
  if(id>CHARTEVENT_CUSTOM)
  //User event is received
  {
  }
//----------------------------------------------------------------------------//  
}
////////////////////////////////////////////////////////////////////////////////
//                           Expert trade function                            //
////////////////////////////////////////////////////////////////////////////////
void OnTrade()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//  
}
////////////////////////////////////////////////////////////////////////////////
//                           Expert tester function                           //
////////////////////////////////////////////////////////////////////////////////
//Function OnTester
double OnTester()
{
//----------------------------------------------------------------------------//
//Work variables
double Result;
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                               Implementation                               //
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
//                               CMqlTradeExpert                              //
//****************************************************************************//
//void CMqlTradeExpert.CMqlTradeExpert
void CMqlTradeExpert::CMqlTradeExpert()
//Constructor of the class
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

Print("CMqlTradeExpert::CMqlTradeExpert");

//Subscribe to obtain data on MarketBook
MarketBookActive = MarketBookAdd(_Symbol);

//----------------------------------------------------------------------------//
}
//****************************************************************************//
//void CMqlTradeExpert.~CMqlTradeExpert
void CMqlTradeExpert::~CMqlTradeExpert()
//Destructor of the class
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

  if(MarketBookActive) MarketBookRelease(_Symbol); 
  
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////